#include <stdio.h>
#include <errno.h>
#include <fcntl.h>

/* @(#) pretty.c 1.1@(#) */

#include "health.h"

void usage(){
	puts("This program will open up /dev/health, and attempt to read");
	puts("temperature and fan speed of your computer");
	puts("temperature #0 usually is cpu temperature");
	puts("temperature #1 is the overall temperature");
}

void printfan(int rpm, int div){
	double realrpm;
	if(rpm==0xff)
	{
		realrpm=0;
	}
	else
	{
		/*realrpm= 1.35E6/(rpm*(1<<div)) ;*/
		realrpm= 1.35E6/(rpm*(div)) ;

	}
	printf("Fan: %d\n", (int)realrpm);
}

void printtemp(int cpunum, int rawtemp)
{
	double celcius=(double)rawtemp;
	printf("temperature  #%d - %f C\n", cpunum, celcius);
}

void printvoltage(unsigned char* volts)
{
	int i;
	printf("Voltage: %d mV\n",(int)(( *(volts+2) )/63.6*1000));
	printf("Voltage: %d mV\n",(int)(( *(volts+3) )/37.0*1000));
	printf("Voltage: %d mV\n",(int)(( *(volts+4) )/16.5*1000));
}



main(int argc, char *argv[]){
	int fd;
	struct rawdata data;

	if(argc!=1){
		usage();
		exit(1);
	}

	fd=open("/dev/health", O_RDONLY);
	if(fd==-1){
		perror("cannot open dev");
		exit(errno);
	}

	if(read(fd, &data, sizeof(data)) <=0){
		perror("error reading from dev");
	}
	printtemp(0,data.cputemp[0]);
	printtemp(1,data.cputemp[1]);

	printfan(data.fanrpm, data.fandiv);

	printvoltage(data.volts);
}

